function init_array(length,mode) 
	local array={} 
	for i=1,length do 
		array[i]=mode end 
	return array 
end

function table.copy(t, lookup_table)
	if (t == nil) then return nil end
	local copy = {}
	setmetatable(copy, getmetatable(t))
	for i,v in pairs(t) do
		if type(v) ~= "table" then
			copy[i] = v
		else
			lookup_table = lookup_table or {}
			lookup_table[t] = copy
			if lookup_table[v] then
				copy[i] = lookup_table[v]
			else
				copy[i] = table.copy(v, lookup_table)
			end
		end
	end
	return copy
end

_menu=menu

menu={}
menu.data={
	["@main_menu"]={
		title="Menu Principal";
		button={
			{name="Inventrio",func="menu.inv_show(v_me)"};
			{name="Loja",target="@shop"};
		}
	};
	["@shop"]={
		title="Loja@b";
		button={
			{name="Menu Principal";caption="Voltar";target="@main_menu"};
		}
	};
	["@buy"]={
		title="Deseja comprar esse item?";
		button={
			{name="Loja";caption="Voltar";target="@shop"};
			{name="Comprar";func="menu.inv_buy(v_me,USER[v_me].sel)"};
			{name="Ver descrio",func="menu.inv_shopdesc(v_me,USER[v_me].sel)"};
		}
	};
	["@equip"]={
		title="Test";
		button={
			{name="Menu Principal",caption="Voltar",target="@main_menu"};
			{name="Usar",func="menu.inv_use(v_me,USER[v_me].sel)"};
			{name="Vender",func="menu.inv_sell(v_me,USER[v_me].sel)"};
			{name="Ver descrio",func="menu.inv_desc(v_me,USER[v_me].sel)"};
			{name="Jogar fora",func="menu.inv_remove(v_me,USER[v_me].sel)"};
		}
	};
}

menu.itemdata={
{name="Poo de HP [250]",price=120,desc="Esta poo recupera totalmente sua saude.",func="heal_p(v_me,250)"};
{name="Poo de HP [100]",price=50,desc="Esta poo recupera sua saude.",func="heal_p(v_me,100)"};
{name="Poo de HP [50]",price=30,desc="Esta poo recupera um pouco sua saude.",func="heal_p(v_me,50)"};
{name="Poo de HP [20]",price=10,desc="Esta poo recupera um pouquinho sua saude.",func="heal_p(v_me,20)"};
}

for index,value in ipairs(menu.itemdata) do menu.data["@shop"].button[index+1]={name=menu.itemdata[index].name;caption=menu.itemdata[index].price.." crditos";func="USER[v_me].sel=(v_slot-1)";target="@buy"} end

USERDATA={
	menu_page="";
	menu_name="";
	sel="";
	inv={};
}

USER=init_array(32,USERDATA)
USER_ITEMS=init_array(32,{})

function menu.get(name,page,button)
	local data={}
	if type(name) == "table" then
		data = name
	else
		data = menu.data[name]
	end
	
	local slot=7*(page-1)+button
	local item=data.button[slot]
	--print(item.name)
	return item,slot
end

function menu.show(uid,name,page)
	local menu_page = page or 1
	local menu_name = name
	local data = {}
	
	if type(name) == "table" then
		data = name
	else
		data = menu.data[name]
	end	

	if data then
		local title = data.title
		local content = data.title
		local button = data.button or {}
		local length = math.ceil(#button/ 7)
			
		if #button > 9 then
			if menu_page < 1 then 
				menu_page = length 
			elseif menu_page > length then 
				menu_page = 1 
			end
				
			for	i = 7 * menu_page - 6, 7 * menu_page do
				if button[i] then 
					content = content ..','..button[i].name
					if button[i].caption then 
						content = content.."|"..button[i].caption
					end	
				else 
					content = content ..',' 
				end
			end
			
			if menu_page == length 
			then content = content ..',(Proximo)'
			else content = content ..',>> Proximo >>|Pagina '..menu_page+1 
			end
	
			if menu_page == 1 
			then content = content ..',(Anterior)' 
			else content = content ..',<< Anterior <<|Pagina '..menu_page-1  
			end	
		else
			for slot,button in ipairs(button) do
				content = content..","..button.name
				if button.caption then
					content = content.."|"..button.caption
				end
			end
		end
	
		USER[uid].menu_name = menu_name
		USER[uid].menu_page = menu_page
		_menu(uid,content)
	end
end

addhook("menu","menu.hook")
function menu.hook(uid,title,button)
	if button==0 then return end
	
	local menu_name = USER[uid].menu_name
	local menu_page = USER[uid].menu_page
	local menu_button = 0
	
	if type(menu_name) == "table" then
		menu_button = #menu_name.button 
	else 
		menu_button = #menu.data[menu_name].button
	end
	
	if menu_button > 9 then
		if button==9 then menu.show(uid,menu_name,menu_page-1) return end
		if button==8 then menu.show(uid,menu_name,menu_page+1) return end
	end
	
	local item,slot=menu.get(menu_name,menu_page,button)
	v_me=uid
	v_slot=slot
		
	if item.func then loadstring(item.func)() end
	if item.target then
		menu.show(uid,item.target)
	end	
end

addhook("serveraction","menu.input")
function menu.input(uid,action)
	if action==3 then
		menu.show(uid,"@main_menu")
	end
end

function menu.inv_remove(uid,item_slot)
	local items=table.copy(USER_ITEMS[uid])
	for slot,item in ipairs(items) do
		if item_slot == slot then
			table.remove(items,slot)
			USER_ITEMS[uid]=items
			break
		end
	end
end

function menu.inv_buy(uid,item_id)
	local item=menu.itemdata[item_id]
	if player(uid,"money") >= item.price then
		msg2(uid,"Voc adquiriu "..item.name.."!")
		menu.inv_add(uid,item_id)
		parse("setmoney "..uid.." "..(player(uid,"money")-item.price))
	else
		msg2(uid,"Voc no tem dinheiro suficiente para comprar "..item.name..".")
	end
end

function menu.inv_shopdesc(uid,item_id)
	local item=menu.itemdata[item_id]
	msg2(uid,item.name..": "..item.desc)
end

function menu.inv_desc(uid,item_slot)
	local item_id=USER_ITEMS[uid][item_slot]
	local item=menu.itemdata[item_id]
	msg2(uid,item.name..": "..item.desc)
end

function menu.inv_use(uid,item_slot)
	local item_id=USER_ITEMS[uid][item_slot]
	loadstring(menu.itemdata[item_id].func)()
	menu.inv_remove(uid,item_slot)
end

function menu.inv_sell(uid,item_slot)
	local item_id=USER_ITEMS[uid][item_slot]
	local item=menu.itemdata[item_id]

	parse("setmoney "..uid.." "..(player(uid,"money")+math.floor(item.price/2)))
	
	msg2(uid,item.name.." vendido por "..item.price.." de cash.")
	menu.inv_remove(uid,item_slot)
end

function menu.inv_add(uid,item_id)
	local item_id=item_id or 1
	local items=table.copy(USER_ITEMS[uid])
	
	table.insert(items,item_id)
		
	if #USER_ITEMS[uid] <= 14 then
		USER_ITEMS[uid] = items
	else
		msg2(uid,"Desculpe, o seu inventrio est cheio.")
	end
end

function menu.inv_show(uid)
	local data=USER_ITEMS[uid]
	local newdata={title="Inventrio";button={{name="Menu Principal",caption="Voltar",target="@main_menu"}}}

	for slot,item_id in pairs(data) do
		newdata.button[slot+1] = {name=(menu.itemdata[item_id].name),func="USER[v_me].sel=(v_slot-1)",target="@equip"}
	end
	menu.show(uid,newdata)
end

function heal_p(uid,amount)
	parse("sethealth "..uid.." "..player(uid,"health")+amount)
	msg2(uid,"Voc foi curado em "..amount.." pontos")
end